VERSION 5.00
Begin VB.UserControl DragButton 
   ClientHeight    =   735
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   735
   ScaleHeight     =   49
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   49
End
Attribute VB_Name = "DragButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Property variables.
Private m_UpPicture As Picture
Private m_DownPicture As Picture

Private m_Dragging As Boolean
Private m_WidPix As Integer
Private m_HgtPix As Integer

Private m_X0 As Single
Private m_Y0 As Single

Public Property Get UpPicture() As Picture
    Set UpPicture = m_UpPicture
End Property

Public Property Set UpPicture(ByVal New_UpPicture As Picture)
    Set m_UpPicture = New_UpPicture
    PropertyChanged "UpPicture"

    UserControl.Picture = m_UpPicture

    If m_UpPicture Is Nothing Then Exit Property
    UserControl.Width = UserControl.ScaleX(m_UpPicture.Width, vbPixels, vbTwips)
    UserControl.Height = UserControl.ScaleY(m_UpPicture.Height, vbPixels, vbTwips)
End Property

Public Property Get DownPicture() As Picture
    Set DownPicture = m_DownPicture
End Property

Public Property Set DownPicture(ByVal New_DownPicture As Picture)
    Set m_DownPicture = New_DownPicture
    PropertyChanged "DownPicture"
End Property

' Initialize properties.
Private Sub UserControl_InitProperties()
    Set m_UpPicture = LoadPicture("")
    Set m_DownPicture = LoadPicture("")
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_Dragging = True

    UserControl.Picture = m_DownPicture
    m_X0 = X
    m_Y0 = Y
End Sub

' Move the form.
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Dragging Then Exit Sub

    ' See how far the mouse has moved since
    ' last time in twips.
    Dim dx As Single
    Dim dy As Single
    dx = ScaleX(X - m_X0, vbPixels, vbTwips)
    dy = ScaleY(Y - m_Y0, vbPixels, vbTwips)

    ' Move the form.
    Dim frm As Form
    Set frm = UserControl.Parent
    frm.Move frm.Left + dx, frm.Top + dy
End Sub
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Dragging Then Exit Sub
    m_Dragging = False
    UserControl.Picture = m_UpPicture
End Sub
' Load property values.
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Set m_UpPicture = PropBag.ReadProperty("UpPicture", Nothing)
    Set m_DownPicture = PropBag.ReadProperty("DownPicture", Nothing)

    UserControl.Picture = m_UpPicture

    If m_UpPicture Is Nothing Then Exit Sub
    UserControl.Width = UserControl.ScaleX(m_UpPicture.Width, vbPixels, vbTwips)
    UserControl.Height = UserControl.ScaleY(m_UpPicture.Height, vbPixels, vbTwips)
End Sub

Private Sub UserControl_Resize()
    m_WidPix = ScaleX(UserControl.Width, vbTwips, vbPixels)
    m_HgtPix = ScaleY(UserControl.Height, vbTwips, vbPixels)

    If m_UpPicture Is Nothing Then Exit Sub
    UserControl.Width = ScaleX(m_UpPicture.Width, vbHimetric, vbTwips)
    UserControl.Height = ScaleY(m_UpPicture.Height, vbHimetric, vbTwips)
End Sub

' Save property values.
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "UpPicture", m_UpPicture, Nothing
    PropBag.WriteProperty "DownPicture", m_DownPicture, Nothing
End Sub
