VERSION 5.00
Begin VB.UserControl PictureButton 
   ClientHeight    =   735
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   735
   ScaleHeight     =   49
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   49
End
Attribute VB_Name = "PictureButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Property variables.
Private m_UpPicture As Picture
Private m_DownPicture As Picture

' Events.
Public Event Click()

Private m_Clicking As Boolean
Private m_WidPix As Integer
Private m_HgtPix As Integer

Public Property Get UpPicture() As Picture
    Set UpPicture = m_UpPicture
End Property

Public Property Set UpPicture(ByVal New_UpPicture As Picture)
    Set m_UpPicture = New_UpPicture
    PropertyChanged "UpPicture"

    UserControl.Picture = m_UpPicture

    If m_UpPicture Is Nothing Then Exit Property
    UserControl.Width = UserControl.ScaleX(m_UpPicture.Width, vbPixels, vbTwips)
    UserControl.Height = UserControl.ScaleY(m_UpPicture.Height, vbPixels, vbTwips)
End Property

Public Property Get DownPicture() As Picture
    Set DownPicture = m_DownPicture
End Property

Public Property Set DownPicture(ByVal New_DownPicture As Picture)
    Set m_DownPicture = New_DownPicture
    PropertyChanged "DownPicture"
End Property

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

' Initialize properties.
Private Sub UserControl_InitProperties()
    Set m_UpPicture = LoadPicture("")
    Set m_DownPicture = LoadPicture("")
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_Clicking = True

    UserControl.Picture = m_DownPicture
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim should_be_pressed As Boolean
Dim is_pressed As Boolean

    If Not m_Clicking Then Exit Sub

    should_be_pressed = _
        (X >= 0 And X < m_WidPix) And _
        (Y >= 0 And Y < m_HgtPix)
    is_pressed = UserControl.Picture Is m_DownPicture

    If is_pressed <> should_be_pressed Then
        If should_be_pressed Then
            UserControl.Picture = m_DownPicture
        Else
            UserControl.Picture = m_UpPicture
        End If
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim should_be_pressed As Boolean

    If Not m_Clicking Then Exit Sub
    m_Clicking = False

    should_be_pressed = _
        (X >= 0 And X < m_WidPix) And _
        (Y >= 0 And Y < m_HgtPix)
    If should_be_pressed Then RaiseEvent Click

    UserControl.Picture = m_UpPicture
End Sub
' Load property values.
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Set m_UpPicture = PropBag.ReadProperty("UpPicture", Nothing)
    Set m_DownPicture = PropBag.ReadProperty("DownPicture", Nothing)

    UserControl.Picture = m_UpPicture

    If m_UpPicture Is Nothing Then Exit Sub
    UserControl.Width = UserControl.ScaleX(m_UpPicture.Width, vbPixels, vbTwips)
    UserControl.Height = UserControl.ScaleY(m_UpPicture.Height, vbPixels, vbTwips)
End Sub

Private Sub UserControl_Resize()
    m_WidPix = ScaleX(UserControl.Width, vbTwips, vbPixels)
    m_HgtPix = ScaleY(UserControl.Height, vbTwips, vbPixels)

    If m_UpPicture Is Nothing Then Exit Sub
    UserControl.Width = ScaleX(m_UpPicture.Width, vbHimetric, vbTwips)
    UserControl.Height = ScaleY(m_UpPicture.Height, vbHimetric, vbTwips)
End Sub

' Save property values.
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "UpPicture", m_UpPicture, Nothing
    PropBag.WriteProperty "DownPicture", m_DownPicture, Nothing
End Sub
